%% Write_pss_css.m

cd '/Users/trugman/Documents/Research/Princeton/Pellegrini_BarkThickness'
%%
DBH = xlsread('transitionalforest_200m2.xlsx');
%DBH = xlsread('savanna_300m2.xlsx');
DBH = DBH (:,2);
plot_area = 200;
pft = 33;
% write .pss and .css file

% write separate .pss and .css file for each patch
latp = -15.9;
lonp = -47.9;

% Header for .css and .pss files
cssHeader = 'time patch cohort dbh hite pft n bdead balive avgRg';
%pssHeader = 'time patch trk age area water fsc stsc stsl ssc dummy msn fsn slsn';
pssHeader = 'time patch trk age area water fsc stsc stsl ssc dummy msn fsn';


%write .pss
pss_time = 0;
pss_patch = 1;
pss_trk = 2;
pss_age = 0;
pss_area = 1.0;
pss_water = 0;
pss_fsc = 0.2;
pss_stsc = 0.2;
pss_stsl = 0;
pss_ssc = 0.2;
pss_dummy = 0;
pss_msn = 15;
pss_fsn = 15;
pss_slsn = 15;
%pss = [pss_time pss_patch pss_trk pss_age pss_area pss_water pss_fsc ...
%   pss_stsc pss_stsl pss_ssc pss_dummy pss_msn pss_fsn pss_slsn];
pss = [pss_time pss_patch pss_trk pss_age pss_area pss_water pss_fsc ...
    pss_stsc pss_stsl pss_ssc pss_dummy pss_msn pss_fsn];


% write
fid = fopen(strcat('forest_pft',num2str(pft),'.lat',num2str(latp),'lon',num2str(lonp),'.pss'),'w+');
% write header
fprintf(fid,'%s\n',pssHeader);
%fprintf(fid,'%d %d %d %d %0.4f %d %0.4f %0.4f %d %0.4f %d %0.4f %0.4f %0.4f\n',pss');
fprintf(fid,'%d %d %d %d %0.4f %d %0.4f %0.4f %d %0.4f %d %0.4f %0.4f\n',pss');

fclose(fid);

% write .css
dbh = DBH;
hite = zeros(length(dbh),1);
PFT = pft * ones(length(dbh),1);
time = zeros(length(dbh),1);
patch = ones(length(dbh),1);
cohort = (1:length(dbh))'*10 + 10000;
n = ones(length(dbh),1) /plot_area;
sap = ones(length(dbh),1);
%css = [time patch cohort dbh hite pft n zeros(length(dbh),3) sap];
css = [time patch cohort dbh hite PFT n zeros(length(dbh),3)];


fid = fopen(strcat('forest_pft',num2str(pft),'.lat',num2str(latp),'lon',num2str(lonp),'.css'),'w+');
fprintf(fid,'%s\n',cssHeader);
disp(size(css,1));
%fprintf(fid,'%d %d %d %.4f %.4f %d %.4f %d %0.4f %0.4f %0.4f\n',css');
fprintf(fid,'%d %d %d %.4f %.4f %d %.4f %d %0.4f %0.4f\n',css');

fclose(fid);



