#!/bin/bash

FR=(3 7 12 20 30 1000)
A=(0.05 0.15 0.3 0.5)

# 1 species, savanna, vary fire return interval
rm ED2IN_savanna_A0.3_FR*
rm run_savanna_A0.3_FR*

ED2IN_prefix="ED2IN_savanna_A0.3_FR"
run_prefix="run_savanna_A0.3_FR"

for ifire in $(seq 0 5)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${FR[$ifire]}"
	cp ./ED2IN_savanna $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = 0.3:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = ${FR[$ifire]}:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/savanna_pft30_A0.3_FR${FR[$ifire]}':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${FR[$ifire]}.slurm"
	cp ./run_savanna.slurm $run_name
	sed -i "s:ED2IN_savanna.*:$ED2IN_name:" $run_name

	#submit the job
#	sbatch $run_name
done

# 1 species, savanna, vary fire area
rm ED2IN_savanna_FR7_A*
rm run_savanna_FR7_A*

ED2IN_prefix="ED2IN_savanna_FR7_A"
run_prefix="run_savanna_FR7_A"

for ifire in $(seq 0 3)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${A[$ifire]}"
	cp ./ED2IN_savanna $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = ${A[$ifire]}:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = 7:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/savanna_pft30_A${A[$ifire]}_FR7':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${A[$ifire]}.slurm"
	cp ./run_savanna.slurm $run_name
	sed -i "s:ED2IN_savanna.*:$ED2IN_name:" $run_name

	#submit the job
#	sbatch $run_name
done

# 1 species, forest, vary fire return interval

rm ED2IN_forest_A0.3_FR*
rm run_forest_A0.3_FR*

ED2IN_prefix="ED2IN_forest_A0.3_FR"
run_prefix="run_forest_A0.3_FR"

for ifire in $(seq 0 5)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${FR[$ifire]}"
	cp ./ED2IN_forest $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = 0.3:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = ${FR[$ifire]}:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/forest_pft33_A0.3_FR${FR[$ifire]}':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${FR[$ifire]}.slurm"
	cp ./run_forest.slurm $run_name
	sed -i "s:ED2IN_forest.*:$ED2IN_name:" $run_name

	#submit the job
#	sbatch $run_name
done

# 1 species, forest, vary fire area
rm ED2IN_forest_FR15_A*
rm run_forest_FR15_A*

ED2IN_prefix="ED2IN_forest_FR15_A"
run_prefix="run_forest_FR15_A"

for ifire in $(seq 0 3)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${A[$ifire]}"
	cp ./ED2IN_forest $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = ${A[$ifire]}:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = 15:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/forest_pft33_A${A[$ifire]}_FR15':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${A[$ifire]}.slurm"
	cp ./run_forest.slurm $run_name
	sed -i "s:ED2IN_forest.*:$ED2IN_name:" $run_name

	#submit the job
#	sbatch $run_name
done

# 2 species, savanna, vary fire return interval

rm ED2IN_savanna2spc_A0.3_FR*
rm run_savanna2spc_A0.3_FR*

ED2IN_prefix="ED2IN_savanna2spc_A0.3_FR"
run_prefix="run_savanna2spc_A0.3_FR"

for ifire in $(seq 0 5)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${FR[$ifire]}"
	cp ./ED2IN_savanna_2spc $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = 0.3:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = ${FR[$ifire]}:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/savanna_pft30-31_A0.3_FR${FR[$ifire]}_sr':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${FR[$ifire]}.slurm"
	cp ./run_savanna2spc.slurm $run_name
	sed -i "s:ED2IN_savanna_2spc.*:$ED2IN_name:" $run_name

	#submit the job
	sbatch $run_name
done

# 2 species, savanna, vary fire area
rm ED2IN_savanna2spc_FR7_A*
rm run_savanna2spc_FR7_A*

ED2IN_prefix="ED2IN_savanna2spc_FR7_A"
run_prefix="run_savanna2spc_FR7_A"

for ifire in $(seq 0 3)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${A[$ifire]}"
	cp ./ED2IN_savanna_2spc $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = ${A[$ifire]}:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = 7:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/savanna_pft30-31_A${A[$ifire]}_FR7_sr':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${A[$ifire]}.slurm"
	cp ./run_savanna2spc.slurm $run_name
	sed -i "s:ED2IN_savanna_2spc.*:$ED2IN_name:" $run_name

	#submit the job
	sbatch $run_name
done

# 2 species, forest, vary fire return interval

rm ED2IN_forest2spc_A0.3_FR*
rm run_forest2spc_A0.3_FR*

ED2IN_prefix="ED2IN_forest2spc_A0.3_FR"
run_prefix="run_forest2spc_A0.3_FR"

for ifire in $(seq 0 5)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${FR[$ifire]}"
	cp ./ED2IN_forest_2spc $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = 0.3:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = ${FR[$ifire]}:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/forest_pft33-34_A0.3_FR${FR[$ifire]}_sr':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${FR[$ifire]}.slurm"
	cp ./run_forest2spc.slurm $run_name
	sed -i "s:ED2IN_forest_2spc.*:$ED2IN_name:" $run_name

	#submit the job
	sbatch $run_name
done

# 2 species, forest, vary fire area
rm ED2IN_forest2spc_FR15_A*
rm run_forest2spc_FR15_A*

ED2IN_prefix="ED2IN_forest2spc_FR15_A"
run_prefix="run_forest2spc_FR15_A"

for ifire in $(seq 0 3)
do 		
	#copy the ED2IN file
	ED2IN_name="$ED2IN_prefix${A[$ifire]}"
	cp ./ED2IN_forest_2spc $ED2IN_name
	# modify the ED2IN
	sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = ${A[$ifire]}:" $ED2IN_name
	sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL = 15:" $ED2IN_name
	sed -i "s:/barkthickness/.*:/barkthickness/brazil_fire/forest_pft33-34_A${A[$ifire]}_FR15_sr':" $ED2IN_name
	
	#copy the run file
	run_name="$run_prefix${A[$ifire]}.slurm"
	cp ./run_forest2spc.slurm $run_name
	sed -i "s:ED2IN_forest_2spc.*:$ED2IN_name:" $run_name

	#submit the job
	sbatch $run_name
done
