#!/bin/bash
rm ED2IN_fire*
rm run_fire*
ED2IN_prefix="ED2IN_fire"
run_prefix="run_fire"

FR=(3 8 10 12 15 25 1000)

#loop over all years all locations
for ibiome in $(seq 1 1)
do
    if [ $ibiome -eq 0 ]
    then
	ED2IN_prefix="ED2IN_fire_forest_FR"
	run_prefix="run_fire_forest_FR"
    elif [ $ibiome -eq 1 ]
    then
	ED2IN_prefix="ED2IN_fire_savanna_FR"
	run_prefix="run_fire_savanna_FR"
    elif [ $ibiome -eq 2 ]
    then
	ED2IN_prefix="ED2IN_fire_mixed_FR"
	run_prefix="run_fire_mixed_FR"	
    fi
    for ifreq in $(seq 0 6)
    do
	for ivm in $(seq 0 0)
	do
		  
	    #copy the ED2IN file
	    ED2IN_name="$ED2IN_prefix${FR[$ifreq]}en$ivm"
	    cp ./ED2IN_forest $ED2IN_name
	    # modify the ED2IN
	    if [ $ibiome -eq 0 ]
	    then
		sed -i "s:/barkthickness/.*:/barkthickness/forest/forest_FR${FR[$ifreq]}en$ivm':" $ED2IN_name
		sed -i "s:/pss_css.*:/pss_css/forest.':" $ED2IN_name
	    elif [ $ibiome -eq 1 ]
	    then
		#sed -i "s:/barkthickness/.*:/barkthickness/savanna/savanna_FR${FR[$ifreq]}en$ivm':" $ED2IN_name
		sed -i "s:/barkthickness/.*:/barkthickness/M91/savannaM91_FR${FR[$ifreq]}':" $ED2IN_name
		sed -i "s:/pss_css.*:/pss_css/Savanna_M91.':" $ED2IN_name
	    elif [ $ibiome -eq 2 ]
            then
		sed -i "s:/barkthickness/.*:/barkthickness/mixed/mixed_FR${FR[$ifreq]}en$ivm':" $ED2IN_name
		sed -i "s:/pss_css.*:/pss_css/mixed.':" $ED2IN_name
            fi
	    sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = 0.3:" $ED2IN_name
	    sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL  = ${FR[$ifreq]}:" $ED2IN_name
	    sed -i "s:.*NL%VMFACT          =.*:   NL%VMFACT = ${ivm}.0:" $ED2IN_name
	    sed -i "s:.*NL%ED_REG_LATMIN.*:   NL%ED_REG_LATMIN  =   -18.0:" $ED2IN_name
	    sed -i "s:.*NL%ED_REG_LATMAX.*:   NL%ED_REG_LATMAX  =   -17.5:" $ED2IN_name
	    sed -i "s:.*NL%ED_REG_LONMIN.*:   NL%ED_REG_LONMIN  =   -47.0:" $ED2IN_name
	    sed -i "s:.*NL%ED_REG_LONMAX.*:   NL%ED_REG_LONMAX  =   -46.5:" $ED2IN_name
			
	    #copy the run file
	    run_name="$run_prefix${FR[$ifreq]}en$ivm.slurm"
	    cp ./run_forest.slurm $run_name
	    sed -i "s:ED2IN.*:$ED2IN_name:" $run_name

	    #submit the job
	    sbatch $run_name
	done
    done
done


