#!/bin/bash
rm ED2IN_fire*
rm run_fire*
ED2IN_prefix="ED2IN_fire"
run_prefix="run_fire"

FR=(3 8 12 25 1000)
D0=(0.0 0.001 0.002 0.003 0.004 0.005 0.006 0.007 0.008 0.009 0.01)

#loop over all years all locations
for ivm in $(seq 0 10)
do
    for ipcp in $(seq 1 1)
    do
	if [ $ipcp -eq 0 ]
	then
	    LATMIN=-15.5
	    LATMAX=-15.0
	    LONMIN=-42.5
	    LONMAX=-42.0
	    MAP=822
	elif [ $ipcp -eq 1 ]
	then
	    LATMIN=-18.5
	    LATMAX=-18.0
	    LONMIN=-44.5
	    LONMAX=-44.0
	    MAP=1150
	elif [ $ipcp -eq 2 ]
	then
	    LATMIN=-22.5
	    LATMAX=-22.0
	    LONMIN=-46.5
	    LONMAX=-46.0
	    MAP=1660
	fi
	
	for ibiome in $(seq 2 2)
	do
	    if [ $ibiome -eq 0 ]
	    then
		ED2IN_prefix="ED2IN_fire_control_MAP${MAP}_FR"
		run_prefix="run_fire_control_MAP${MAP}_FR"
	    elif [ $ibiome -eq 1 ]
	    then
		ED2IN_prefix="ED2IN_fire_BT_MAP${MAP}_FR"
		run_prefix="run_fire_BT_MAP${MAP}_FR"
	    elif [ $ibiome -eq 2 ]
	    then
		ED2IN_prefix="ED2IN_fire_BTtradeoff_MAP${MAP}_FR"
		run_prefix="run_fire_BTtradeoff_MAP${MAP}_FR"
	    elif [ $ibiome -eq 3 ]
	    then
		ED2IN_prefix="ED2IN_fire_resprout_MAP${MAP}_FR"
		run_prefix="run_fire_resprout_MAP${MAP}_FR"
	    fi
	    for ifreq in $(seq 1 1)
	    do
		
		#copy the ED2IN file
		ED2IN_name="$ED2IN_prefix${FR[$ifreq]}_pen${D0[$ivm]}"
		cp ./ED2IN_forest $ED2IN_name
		# modify the ED2IN
		if [ $ibiome -eq 0 ]
		then
		    sed -i "s:/barkthickness/.*:/barkthickness/nbg_control/control_MAP${MAP}_FR${FR[$ifreq]}':" $ED2IN_name
		    sed -i "s:.*NL%INCLUDE_THESE_PFT.*:   NL%INCLUDE_THESE_PFT = 24,26,27,29,1:" $ED2IN_name
		elif [ $ibiome -eq 1 ]
		then
		    sed -i "s:.*NL%INCLUDE_THESE_PFT.*:   NL%INCLUDE_THESE_PFT = 31,34,1:" $ED2IN_name
		    #sed -i "s:.*NL%INCLUDE_THESE_PFT.*:   NL%INCLUDE_THESE_PFT = 30,31,32,33,34,35,1:" $ED2IN_name
		    sed -i "s:/barkthickness/.*:/barkthickness/nbg_BT/BT_MAP${MAP}_FR${FR[$ifreq]}':" $ED2IN_name
		elif [ $ibiome -eq 2 ]
		then
		    sed -i "s:/barkthickness/.*:/barkthickness/penalty_sensitivity/BTtradeoff_MAP${MAP}_FR${FR[$ifreq]}_pen${D0[$ivm]}':" $ED2IN_name
		    sed -i "s:.*NL%INCLUDE_THESE_PFT.*:   NL%INCLUDE_THESE_PFT = 33,34,1:" $ED2IN_name
		elif [ $ibiome -eq 3 ]
		then
		    sed -i "s:/barkthickness/.*:/barkthickness/nbg_resprout/resprout_MAP${MAP}_FR${FR[$ifreq]}':" $ED2IN_name
		    sed -i "s:.*NL%INCLUDE_THESE_PFT.*:   NL%INCLUDE_THESE_PFT = 31,34,1:" $ED2IN_name
		fi
		sed -i "s:.*NL%FIRE_AREA = .*:   NL%FIRE_AREA = 0.3:" $ED2IN_name
		sed -i "s:.*NL%FIRE_INTERVAL =.*:   NL%FIRE_INTERVAL  = ${FR[$ifreq]}:" $ED2IN_name
		sed -i "s:.*NL%VMFACT          =.*:   NL%VMFACT = 0.0:" $ED2IN_name
		sed -i "s:.*NL%ED_REG_LATMIN.*:       NL%ED_REG_LATMIN  =   ${LATMIN}:" $ED2IN_name
		sed -i "s:.*NL%ED_REG_LATMAX.*:       NL%ED_REG_LATMAX  =   ${LATMAX}:" $ED2IN_name
		sed -i "s:.*NL%ED_REG_LONMIN.*:       NL%ED_REG_LONMIN  =   ${LONMIN}:" $ED2IN_name
		sed -i "s:.*NL%ED_REG_LONMAX.*:       NL%ED_REG_LONMAX  =   ${LONMAX}:" $ED2IN_name
		sed -i "s:.*NL%IYEARZ.*:   NL%IYEARZ  =  2310:" $ED2IN_name
		sed -i "s:.*NL%D0FACT.*:   NL%D0FACT  =  ${D0[$ivm]}:" $ED2IN_name
		sed -i "s:.*NL%RUNTYPE.*:    NL%RUNTYPE  = 'HISTORY':" $ED2IN_name
		sed -i "s:.*NL%IED_INIT_MODE.*:    NL%IED_INIT_MODE   = 4:" $ED2IN_name
		sed -i "s:   NL%SFILIN.*:   NL%SFILIN = '/scratch/gpfs/att/barkthickness/penalty_sensitivity/BTtradeoff_MAP${MAP}_FR${FR[$ifreq]}_pen${D0[$ivm]}':" $ED2IN_name
		sed -i "s:.*NL%IYEARH.*:    NL%IYEARH = 2090:" $ED2IN_name
		
		#copy the run file
		run_name="$run_prefix${FR[$ifreq]}_pen${D0[$ivm]}.slurm"
		cp ./run_forest.slurm $run_name
		sed -i "s:ED2IN.*:$ED2IN_name:" $run_name

		#submit the job
	        sbatch $run_name
	    done
	done
    done
done


